# -*- coding: utf-8 -*-
"""
    demeter web page
    name:deploy.py 上线代码相关
    author:rabin
"""
from .__load__ import *

class project_path(Load):
	@Web.auth
	@Web.setting
	def get(self):
		self.set(
			name = u'项目管理'
			,path = '/deploy/project'
			,width = '500'
			,height = '500'
			,search = (('label-1','cdate-time-start','cdate-time-end','name-input-mlike'), (u'日期范围',u'开始时间',u'截止时间',u'项目名称'))
			,thead = (u'项目ID', u'项目名称', u'更新时间')
			,tbody = ('id','name', 'cdate')
			,state = True
		)

		self.list('project')
		self.show('list')

class project_update_path(Load):
	@Web.auth
	@Web.setting
	def get(self):
		self.set(
			path = '/deploy/project'
			,label = (u'项目名称',u'项目key',u'节点id',u'git地址',u'可写目录-多个用换行隔开，直接填写可写目录名称即可',u'配置目录-多个用换行隔开，直接填写配置目录名称即可')
			,update = ('name-input-required','key-input-required','node_id-checkbox-required','git-input-required','write-text--data/','config-text--config/env/')
			,update_node_id = self.service('common').list('node')
		)
		self.one('project')
		self.show('update')
	@Web.auth
	@Web.setting
	def post(self):

		if 'git_path' in Demeter.config['admin']:
			path = Demeter.config['admin']['git_path']
			git = self.data['update']['git']
			name = self.data['update']['key']
			project = path + name
			if not File.exists(project):
				Shell.popen('cd ' + path + ' && git clone ' + git + ' ' + name, bg=True)

		self.update('project')
	@Web.auth
	@Web.setting
	def delete(self):
		self.drop('project')


class submit_path(Load):
	@Web.auth
	@Web.setting
	def get(self):
		self.set(
			name = u'代码提交'
			,path = '/deploy/submit'
			,width = '500'
			,height = '500'
			,search = (('label-1','cdate-time-start','cdate-time-end','file-input-mlike'), (u'日期范围',u'开始时间',u'截止时间',u'提交文件'))
			,thead = (u'提交ID', u'所属项目', u'提交文件', u'提交描述', u'提交人', u'提交时间')
			,tbody = ('id','project','file','desc','admin', 'cdate')
			,state = True
		)

		self.list('code')
		if self.data['list']:
			for key, value in enumerate(self.data['list']):
				project = self.service('common').one('project', id=value['project_id'])
				self.data['list'][key]['project'] = project['name']

				admin = self.service('common').one('manage_admin', id=value['admin'])
				self.data['list'][key]['admin'] = admin['username']
		self.show('list')

class submit_update_path(Load):
	@Web.auth
	@Web.setting
	def get(self):
		self.set(
			path = '/deploy/submit'
			,label = (u'所属项目',u'提交文件-多个换行隔开',u'提交描述')
			,update = ('project_id-select-required','file-text-required','desc-text-required')
			,update_project_id = self.service('common').list('project')
		)
		self.one('code')
		self.show('update')
	@Web.auth
	@Web.setting
	def post(self):

		self.data['update']['admin'] = self.data['setting']['admin']
		if 'git_path' in Demeter.config['admin'] and 'online_path' in Demeter.config['admin']:
			path = Demeter.config['admin']['git_path']
			online = Demeter.config['admin']['online_path']
			project_id = self.data['update']['project_id']
			project_info = self.service('common').one('project', id=project_id)
			write = project_info['write'].split("\r\n")
			config = project_info['config'].split("\r\n")
			name = project_info['key']
			file = self.data['update']['file']
			project = path + name + '/'
			online_project = online + name + '/'
			if File.exists(project):
				if not File.exists(online_project) or file == '/':
					command = 'cp -R ' + project + ' ' + online_project + ' && rm -rf '+online_project+'.git/ && chmod -R 777 ' + online_project + 'data/'
				else:
					file = file.split("\r\n")
					files = []
					for i in file:
						c = 'cp -R ' + project + i + ' ' + online_project + i + ' '
						for j in write:
							if j in i:
								c = c + ' && chmod -R 777 ' + online_project + i + ' '
						files.append(c)
					command = '&&'.join(files)

				Shell.popen('cd ' + project + ' && git pull && ' + command, bg=True)

		self.update('code')
	@Web.auth
	@Web.setting
	def delete(self):
		self.drop('code')