# -*- coding: utf-8 -*-
"""
    demeter web page
    name:server.py 服务器相关
    author:rabin
"""
from .__load__ import *

class domain_path(Load):
	@Web.auth
	@Web.setting
	def get(self):
		self.set(
			name = u'域管理'
			,path = '/server/domain'
			,width = '500'
			,height = '200'
			,search = (('label-1','cdate-time-start','cdate-time-end','name-input-mlike'), (u'日期范围',u'开始时间',u'截止时间',u'域名称'))
			,thead = (u'域ID', u'域名称', u'更新时间')
			,tbody = ('id','name', 'cdate')
			,state = True
		)

		self.list('domain')
		self.show('list')

class domain_update_path(Load):
	@Web.auth
	@Web.setting
	def get(self):
		self.set(
			path = '/server/domain'
			,label = (u'域名称',)
			,update = ('name-input-required',)
		)
		self.one('domain')
		self.show('update')
	@Web.auth
	@Web.setting
	def post(self):
		self.update('domain')
	@Web.auth
	@Web.setting
	def delete(self):
		self.drop('domain')

class node_path(Load):
	@Web.auth
	@Web.setting
	def get(self):
		self.set(
			name = u'节点管理'
			,path = '/server/node'
			,width = '500'
			,height = '300'
			,search = (('label-1','cdate-time-start','cdate-time-end','domain_id-select-','name-input-mlike'), (u'日期范围',u'开始时间',u'截止时间',u'选择域', u'节点名称'))
			,thead = (u'节点ID', u'节点名称', u'域名', u'节点IP', u'更新时间')
			,tbody = ('id', 'name', 'domain', 'ip', 'cdate')
			,state = True
		)

		self.data['common']['search_domain_id-select-'] = self.service('common').list('domain')

		self.list('node')
		if self.data['list']:
			for key, value in enumerate(self.data['list']):
				data = self.service('common').one('domain', id=value['domain_id'])
				self.data['list'][key]['domain'] = data['name']

		self.show('list')

class node_update_path(Load):
	@Web.auth
	@Web.setting
	def get(self):
		self.set(
			path = '/server/node'
			,label = (u'节点名称', u'选择域', u'节点IP')
			,update = ('name-input-required','domain_id-select-required', 'ip-input-required')
			,update_domain_id = self.service('common').list('domain')
		)
		self.one('node')
		self.show('update')
	@Web.auth
	@Web.setting
	def post(self):
		self.update('node')
	@Web.auth
	@Web.setting
	def delete(self):
		self.drop('node')



class category_path(Load):
	@Web.auth
	@Web.setting
	def get(self):
		self.set(
			name = u'镜像分类管理'
			,path = '/server/category'
			,width = '500'
			,height = '200'
			,search = (('label-1','cdate-time-start','cdate-time-end','name-input-mlike'), (u'日期范围',u'开始时间',u'截止时间',u'分类名称'))
			,thead = (u'分类ID', u'分类名称', u'更新时间')
			,tbody = ('id','name', 'cdate')
			,state = True
		)

		self.list('category')
		self.show('list')

class category_update_path(Load):
	@Web.auth
	@Web.setting
	def get(self):
		self.set(
			path = '/server/category'
			,label = (u'分类名称',)
			,update = ('name-input-required',)
		)
		self.one('category')
		self.show('update')
	@Web.auth
	@Web.setting
	def post(self):
		self.update('category')
	@Web.auth
	@Web.setting
	def delete(self):
		self.drop('category')

class images_path(Load):
	@Web.auth
	@Web.setting
	def get(self):
		self.set(
			name = u'镜像管理'
			,path = '/server/images'
			,width = '500'
			,height = '300'
			,search = (('label-1','cdate-time-start','cdate-time-end','category_id-select-','name-input-mlike'), (u'日期范围',u'开始时间',u'截止时间',u'选择分类', u'镜像名称'))
			,thead = (u'镜像ID', u'镜像名称', u'分类', u'更新时间')
			,tbody = ('id', 'name', 'category', 'cdate')
			,state = True
		)

		self.data['common']['search_category_id-select-'] = self.service('common').list('category')

		self.list('images')
		if self.data['list']:
			for key, value in enumerate(self.data['list']):
				data = self.service('common').one('category', id=value['category_id'])
				self.data['list'][key]['category'] = data['name']

		self.show('list')

class images_update_path(Load):
	@Web.auth
	@Web.setting
	def get(self):
		self.set(
			path = '/server/images'
			,label = (u'镜像名称', u'选择分类')
			,update = ('name-input-required','category_id-select-required')
			,update_category_id = self.service('common').list('category')
		)
		self.one('images')
		self.show('update')
	@Web.auth
	@Web.setting
	def post(self):
		self.update('images')
	@Web.auth
	@Web.setting
	def delete(self):
		self.drop('images')


class group_path(Load):
	@Web.auth
	@Web.setting
	def get(self):
		self.set(
			name = u'容器分组管理'
			,path = '/server/group'
			,width = '500'
			,height = '200'
			,search = (('label-1','cdate-time-start','cdate-time-end','name-input-mlike'), (u'日期范围',u'开始时间',u'截止时间',u'组名称'))
			,thead = (u'组ID', u'组名称', u'更新时间')
			,tbody = ('id','name', 'cdate')
			,state = True
		)

		self.list('group')
		self.show('list')

class group_update_path(Load):
	@Web.auth
	@Web.setting
	def get(self):
		self.set(
			path = '/server/group'
			,label = (u'组名称',)
			,update = ('name-input-required',)
		)
		self.one('group')
		self.show('update')
	@Web.auth
	@Web.setting
	def post(self):
		self.update('group')
	@Web.auth
	@Web.setting
	def delete(self):
		self.drop('group')

class container_path(Load):
	@Web.auth
	@Web.setting
	def get(self):
		self.set(
			name = u'容器管理'
			,path = '/server/container'
			,width = '500'
			,height = '300'
			,search = (('label-1','cdate-time-start','cdate-time-end','group_id-select-','images_id-select-','name-input-mlike'), (u'日期范围',u'开始时间',u'截止时间',u'选择分组',u'选择镜像', u'容器名称'))
			,thead = (u'容器ID', u'容器名称', u'分组', u'镜像', u'更新时间')
			,tbody = ('id', 'name', 'group', 'images', 'cdate')
			,state = True
		)

		self.data['common']['search_group_id-select-'] = self.service('common').list('group')
		self.data['common']['search_images_id-select-'] = self.service('common').list('images')

		self.list('container')
		if self.data['list']:
			for key, value in enumerate(self.data['list']):
				data = self.service('common').one('group', id=value['group_id'])
				self.data['list'][key]['group'] = data['name']

				data = self.service('common').one('images', id=value['images_id'])
				self.data['list'][key]['images'] = data['name']

		self.show('list')

class container_update_path(Load):
	@Web.auth
	@Web.setting
	def get(self):
		self.set(
			path = '/server/container'
			,label = (u'容器名称', u'选择分组', u'选择镜像')
			,update = ('name-input-required','group_id-select-required','images_id-select-required')
			,update_group_id = self.service('common').list('group')
			,update_images_id = self.service('common').list('images')
		)
		self.one('container')
		self.show('update')
	@Web.auth
	@Web.setting
	def post(self):
		self.update('container')
	@Web.auth
	@Web.setting
	def delete(self):
		self.drop('container')